# -*- Mode: Perl -*-
# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

use Test;

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; plan tests => 22; }
use Set::Hashed;
ok(1);

$^W = 1;

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):
ok($s = Set::Hashed->new()); # 2

ok($s->insert(qw(a b c))); # 3

ok($s->member('a') && $s->member('b') && $s->member('c')); # 4

ok($s->size, 3); # 5

ok($t = $s->clone); # 6

#ok($t->delete(qw(a b)));
$t->delete(qw(a b));

ok(!$t->member('a') && !$t->member('b') && $t->member('c')); # 7

#ok($t->insert(1));
$t->insert(1);

ok($u = $s->union($t)); # 8

ok($u->member('a') && $u->member('b') && $u->member('c') && $u->member(1)); # 9

ok($i = $s->intersection($t)); # 10

ok(!$i->member('a') && !$i->member('b') && $i->member('c') && !$i->member(1)); # 11

ok($d = $s->difference($t)); # 12

ok($d->member('a') && $d->member('b') && !$d->member('c') && !$d->member(1)); # 13

$n = Set::Hashed->new();
ok($n->is_null); # 14
ok($s->is_equal($s)); # 15
ok($i->is_subset($s)); # 16
ok($i->is_proper_subset($s)); # 17

# undef tests
ok($i->insert(undef)); # 18
ok($i->member(undef),''); # 19
ok($i->contains(qw(a b c)), 0); # 20
ok($i->contains(qw(a b), undef, qw(c)), 0); # 21
ok($i->remove(undef)); # 22
